                     Computer Science 851
                           Quiz 1           Name _______________________

Terminology:  the very highest layer is the APPLICATION LAYER = Layer 7
              these questions refer to the ISO/OSI 7 layer model

1. a. Which of the seven layers of the ISO-OSI model is the LOWEST
      layer that is typically found in each host computer but not
      found in an router/switch/IMP (give name not layer number)




   b. Which layer is responsible for routing and congestion control.
     (give name not layer number)





2. Protocol headers used by a layer N are handled by layer K (K < N)
   as follows:

   a. The are removed before  b. They are treated as user data.
      the packet arrives at
      Layer K


   c. They are deleted by layer K.


3. In the "apocalypse of the two elephants"

   what do the X and Y axes represent:

   X -


   Y -

4. Two things that a protocol can do to earn the term "unreliable"
   are (1) deliver packets with bits that have been inverted and
   (2) lose packets.  Identify two others:

   a.


   b.


5. Do protocols (as the term is normally used in networking, e.g
   in SDLC, TCP, or IP) define the rules under which a layer communicates

   a. With the layer above it   b. With a peer layer in another node.


   c. With the layer below it.  d. All of the above.


6. For each of the following layers answer (E) if the layer has only
   endpoint-to-endpoint interoperability issues (P) if the layer has
   only point-to-point interoperability issues and (G) if the layer
   has global interoperability issues

   ___ a. Presentation


   ___ b. Data link


   ___ c. Network


7. Place the following protocols at the correct location in the
    boxes below:  TCP, IP, ATM


                   Connection        Connection
                   Oriented             Less
               ___________________________________
               |                 |               |
     Reliable  |                 |               |
               |                 |               |
               |_________________|_______________|
               |                 |               |
     Unreliable|                 |               |
               |                 |               |
               |_________________|_______________|



8. What is the number of distinct signalling states needed to transmit
   16,000 bits per second on a channel if the duration of a signalling
   state is 0.001 seconds?






9. The bit rate is the same as the baud rate

    a. Always                         b. never

    c. if and only if two bits are    d. if and only if two signalling
       transferred by each               states are used.
       signalling state.



10. In the Linux implementation of TCP/IP the "protocol family" sublayer
    is part of which layer:

    a. application                    b. transport

    c. network                        d. link



                     Computer Science 515
                           Quiz 2           Name _______________________

1. What bandwidth is required to support a bit rate of  64,000 BPS
   on a channel with a 30dB SNR?










2.  Recall the Bell 212A modem discussed in class.  It signalled using
    4 phase angles, 45, 135, 225, and 315 degrees.
    When a long burst of 00000000000000000000 is transmitted,

   a. The modem will emit a             b. There will be a +45 degree
      pure sine wave of the form           phase shift in the signal
      f(t) = sin(wt + 45deg)               every bit time.
      for the duration of the burst

   c. There will be a +45 degree
      phase shift every other bit
      time.


3. In addition to the phase angle, identify two other parameters of
   a sine wave signal that are commonly modulated.

   1 -



   2 -


4. The use of very small slot sizes in a TDM multiplexing scheme is:

   a. Inefficient and shouldn't       b. Generally shouldn't be used for
      be used in either STDM or ATDM     SDTM but is OK for ATDM

   c. Generally shouldn't be used     d. Perfectly OK for both
      for ATDM but is OK for STDM

5. Suppose a PCM scheme supports a bit rate of  80,000 bps and
   quantizes the signal into 256 distinct levels.  What is the
   highest frequency that it can carry?









6. What bit rate is required to support a new "hi-fi" PCM phone
   that supports frequencies to 16Khz and quantizes the signal
   into 4096 discrete levels.






7. The DS-0 digital telephone signal carries

   a. 1 Bit every 125 usec            b. 1 Byte every 125 usec

   c. 8 Bytes every 125 usec


8. The number of voice telephone connections that can be simultaneously
    multiplexed onto a single OC-1/STS-1 circuit is closest to:

   a. 51                                b. 775

   c. 6,480                             d. 1.544 Million


9. In QAM the two carriers that are amplitude modulated

   a. use the same frequency and       b. use the same frequency but are
      phase                               90 degrees out of phase

   c. use different frequencies and
      are 90 degrees out of phase


10. QAM-16 sends

    a. 4 bits per baud time             b. 6 bits per baud time

    c. 8 bits per baud time             d. 64 bits per baud time.


11. In QAM 16 the each of the two carriers use

    a. 64 different amplitudes          b. 16 different amplitudes

    c. 8 different amplitudes           d. 4 different amplitudes


12. With currently deployed WDM technology, the aggregate bit rate that can
    be carried by a single optical fiber is closest to:

    a. one million bits / sec           b. one billion bits /sec

    c. ten billion bits / sec           d. one trillion bits / sec







                     Computer Science 851
                           Quiz 3           Name _______________________

1. Suppose a network has links that carry data at a rate of 10,000
   bits per second.  Suppose Node A and Node B are connected by a
   path that requires 8 hops (transmissions).

   a. What is the minimum time required to send a 1,000,000 bit message
      from A to B if message switching is used.









   b. Suppose packet switching is used and no additional bits are
      required for headers. How long will it take to send the entire
      message if 2000 bit packets are used.









2. Suppose headers of length 200 bits are used in the packet switching
   scheme described above. Suppose packet size remains at 2000 bits
   which now includes header+data bits).  Under this new scheme:

   a. How  many packets must be sent?







   b. How long will it be before the LAST packet leaves the original
      sender







3. For a slotted aloha system  there are two different values of
   G which will result in the throughput being "S". For a given "S"
   the average delay before a packet is successfully transmitted  is:

   a. The same for both "G"s          b. Larger for the small "G"
                                         than for the big "G".

   c. Larger for the big "G"          d. Totally independent of
      than for the small "G".            the "G" value.

4. Suppose a slotted aloha channel is observed to experience 0.8
   transmission attempts per packet time.

   a. What is probability that a given transmission will succeed?






   b. What is the throughput in packets per packet time?






5. Suppose a WiMAX system uses a bandwidth of 6.4 Mhz and OFDM with QAM.
   There are 64 subchannels of which 50 are used to carry data.

   a. What is the bandwidth of each subchannel





   b. What is the basic FFT symbol time (doesn't include guard intervals)
      in a WiMAX standard system.






   c. Assuming 0 guard intervals and are used what will be the maximum
      sustained throughput in bits/second (assuming 50/50 upstream downstream
      split and QAM 16 1/2 modulation in each channel.













7. In a shared medium network using an increasingly agressive transmission
   strategy causes:

   a. time in both collision and           b. time in collision to increase
      idle state to increase                  time in idle to decrease

   c. time in collision to decrease        d. both to decrease
      and idle to increase



                      Computer Science 851
                         Quiz 4              Name _______________________

1. In a dual persistent protocol a station transmits with prob p
   when it initially sense a channel idle and with prob q when
   it has to wait for a busy channel to become idle.  The proper
   relationship between p and q is:

   a. p < q                            b. p > q

   c. p = q                            d. q = 1 and p < q

2. In a dual persistent scheme INCREASING the value of q will
   tend to:

   a. increase both the number of      b. increase idle but reduce
      collisions and the amount           collisions
      of idle time.

   c. increase collisions and reduce   d. have no effect on collisions
      idle                                or idle

3. In a hypothetical p-persistent Ethernet once proposed by Prof. Westall
   the value of "p" changed as a function of the recent collision rate
   (collisions / second).  In such a scheme

   a. when the collision rate increases  b. when the collision rate
      the value of "p" should decrease      increases so should the value
                                            of p.

   c. The value of "p" should be randomly
      chosen each time the collision rate
      changes.

4. The main function of the CD portion of a CSMA-CD protocol is to:

   a. Reduce the probability that     b. Reduce amount of wasted time
      a collision will occur.            when a collision occurs.

   c. Ensure that no collisions       d. Both a and b.
      occur at all.

5. The objective of the CS part of the CSMA-CD  protocol is to:

   a. Reduce the amount of time        b. Reduce the number of
      caused by collisions that           collisions that occur
      do occur

   c. Reduce the amount of idle        d. All of the above.
      time in which all stations
      are silent

6. If all packets on a CSMA ethernet are sufficiently small
   that the packet time is appproximately 2 tau, our model predicts

    a. expected throughput will       b. similar to an Aloha
       still be way better than          system
       any Aloha system.

    c. effectively 0.  

7. Parameters that effect the efficiency of a CSMA channel include
   the bit rate B, the packet size P, and the length of the wire L.
   For each parameter indicate whether increasing the value of the
   parameter will increase (I) or decrease (D) the efficiency of
   the channel.

   ___ a. Bit rate

   ___ b. Packet size

   ___ c. Length of the wire

8. Multiple transmissions of data can occur simultaneously and non-destructively
   on which of the following LANs (Check ALL that apply)

   a. A shared bus CSMA CD ethernet   b. A switched ethernet.

   c. A token bus                     d. A token ring


9. For each of the following Token Bus control frame, answer U if the
   frame can be unicast and B if it must be sent as a link level broadcast

   ___ a. SOLICIT_SUCCESSOR


   ___ b. SET_SUCCESSOR


   ___ c. WHO_FOLLOWS

10. In a token ring, bits are drained into the "bit bucket" when the
   interface is operating in:

   a. recieve mode                    b. transmit mode

   c. store and forward mode          d. all of the above


11. For the IEEE token bus match the control packets with the conditions
    underwhich they are used. (Some answers may or may not be used
    multiple times and some may or may not be used at all.)

   ____ a. A station recognizes a WHO_FOLLOWS   1. SOLICIT_SUCCESSOR_2
           packet specifying its predecessors
           address.                             2. SET_SUCCESSOR_2

   ____ b. A station wishes to leave the net.
                                                3. WHO_FOLLOWS

   ____ c. A station transmits the token twice  4. RESOLVE_CONTENTION
           without hearing its successor
           transmit a token or a packet.        5. CLAIM_TOKEN

   ____ d. The station having the lowest MAC    6. SOLICIT_SUCCESSOR
           address on the bus wishes to invite
           a new station to join the net.       7. SET_SUCCESSOR



                      Computer Science 851
                         Quiz 5              Name _______________________

1. Provide a 4 chip sequence that is orthogonal to:   +1 -1 +1 -1




2. Dr. Westall claims that it is IMPOSSIBLE to find a 5 chip sequence
   that is orthogonal to   +1 -1 +1 -1 +1.  If his claim is FALSE find
   such a sequence.  If his claim is true EXPLAIN why he is correct.











3. In Direct Sequence Spread Spectrum the receiver takes the
   dot product of the chip sequence received with the senders
   chipping code.  A value of exactly 0 indicates:

   a. A zero bit was sent              b. a one bit was sent

   c. the channel is so noisy it
      is not possible to tell what
      was sent.


4. Which of the following does 802.3 ethernet DO but 802.11 wireless
   does NOT DO. (Identify ALL that apply)

   a. sense the carrier before         b. detect collisions
      transmitting

   c. Jam the medium after a collision
      is detected


5. In an 802.11 system exactly which of the following frame types may NOT
   be transmitted immediately following the SIFS (Circle all that apply.)

   a. RTS                              b. CTS

   c. ACK                              d. Poll


6. The primary motivation for the use of fragmentation in 802.11
   but not in 802.3 (ethernet) is:

   a. Ethernet has a higher            b. 802.11 uses much larger
      bit rate                            packets

   c. 802.11 has a much higher
      bit error probability

7. In an 802.11b network suppose that while station A is waiting
   for its backoff slot counter to count down to zero station B
   begins transmission. Which best characterizes the behavior of
   station A during the transmission of station B.

   a. its backoff slot counter will    b. the count down will be
      continue to count down and if       suspended during station B's
      it reaches 0 station A will Tx      Tx and will resume
      as soon as station B finishes       as soon as station B finishes

   c. When station B finishes station  d. When station B finishes, station
      A will reset the counter to its     A will double the size of the CWin
      original starting value and         draw a new random number and
      restart the countdown.              restart the countdown.

8. The type of wireless lan most likely to be deployed in home and
    office locations typically operates in:

    a. ad hoc mode                     b. infrastructure mode with PCF

    c. infrastructure mode with
       DCF

9. In an 802.11b network, stations must randomly select wcount and
   delay wcount slots

   a. Every time a packet is sent      b. Only if the channel is
                                          initially sensed busy

   c. Only after a collision occurs


10. In an 802.11e which of the following parameters allow a single TC0
    flow to completely starve a single competing TC1 flow (circle all that
    apply:

               TC0                            TC1
        AIFS  CWMin   CWMax            AIFS  CWmin  CWmax
    a.   2      8       16              2     20    64

    b.   2      8       40              4     50   120

    c.   2      8       16             12     50   120

    d.   2      8      200             12     50   120

11. Order the following wireless technology according to
    range.  (1) is the longest range:


    ___ a. 802.11


    ___ b. 802.16


    ___ c. Bluetooth


                      Computer Science 851
                         Quiz 6              Name _______________________

1. Which best characterizes the physical layers of 802.11 and DOCSIS

   a. Both use shared medium           b. Dedicated point to point
      physical channels                   channels are used in both

   c. 802.11 uses shared but           d. 802.11 uses dedicated but
      DOCSIS uses dedicated               DOCSIS uses shared

2. a. Suppose a DOCSIS system is set up as follows: Basic tick = 6.25
      usec, and that a mini-slot consists of 32 basic ticks and that a
      MAP is sent out every 8 msec.  How many mini-slots does the MAP
      map??






   b. Suppose physical bit rate on the channel is 5.12 * 10^6 bits /second.
      How many bytes can each mini-slot carry?







   c. Suppose a telephone service requires 64,000 bits per second UGS.
      How many mini-slots must be granted in each frame. (HINT: assume
      a fixed number of mini-slots must be granted in EACH FRAME).







3. In DOCSIS the MAP
   (Upstream means toward the ISP's CMTS, Downstream means toward
    the cable modem)

    a. is transmitted downstream and   b. is transmitted upstream and
       describes how the downstream       describes how the upstream
       channel is to be allocated         channel is to be allocated

    c. is transmitted upstream and     d. is transmitted downstream and
       describes how the downstream       describes how the upstream
       channel is to be allocated         channel is to be allocated


4. In a DOCSIS or WiMAX network Dynamic Service Activation (DSA) is
   important for

   a. UGS service but not BE           b. BE Service but not UGS

   c. Equally important for BE and     d. Only important for RTPS
      UGS 
5. Suppose two cable modem customers are on the same cable segment
   and one wishes to send a file to another.  Which of the following
   best describes the situation

   a. since they are on the same      b. Since they are on the same
      cable segment the data can         segment it is impossible for
      be sent directly from one CM       them to exchange any IP
      to the other.                      packets at all.

   c. They can communicate but
      all packets must be sent upstream
      to the CMTS and then back
      downstream to the other CM

6. The amount of contention in a DOCSIS network can be reduced by a
   procedure called piggybacking.  Piggybacking is  most useful for

   a. UGS flows                         b. BE flows

   c. RTPS flows                        d. All of the above

Suppose that EXACTLY 2 stations, both with an infinite backlog of
traffic are contending for access to a shared channel.  Suppose
station A always randomly sets its backoff counter to one of the
values {0, 1} and station B always sets its counter to one of the
values {0, 1, 2}


8. In the long term in what fraction of the slots will there be
    collisions




9. Suppose a BISYNCH message consists of the following byte pattern
   while it is "on the wire". Write down the data part of the message
   AFTER the receiver removes the "stuffed" bytes.

               |    this is the data part of the msg     |
   ------------------------------------------------------------------
   | DLE | STX | 'A' | DLE | DLE | 'B' | DLE | DLE | ETX | DLE | ETX |
   ------------------------------------------------------------------





10. In SDLC bit stuffing algorithm the loss of an end flag (framing
   character) can be detected by:

   a. The appearance of some 0's       b. The appearance of some 1's where
      where there should only be 1's      there should only be 0's.

   c. The appearance of all 1's        d. The appearance of all 0's where
      where there should be a mix of      there should be a mix of 1's
      1's and 0's                         and 0's.

                      Computer Science 851
                         Quiz 7              Name _______________________


1. Suppose a 7 bit codeword with ODD parity is being used in a
   single bit hamming ECC.  Suppose the  following codeword is
   received.

      1  1  1  0  0  1  1
      -------------------
      1  2  3  4  5  6  7

   Which (if any) bit is in error?




2. a. Suppose a single bit Hamming ECC is to be performed on a
      1023 bit codeword. How many bits are in each of the parity
      checked groups (include the parity bit itself).



   b. How many distinct parity checked groups are there?




   c. How many distinct parity groups does bit 259 belong to.




   d. Which (if any) bit belongs to EVERY parity checked group.






3. In the error detection business it is in general easier to detect
   errors in which

    a. An even number of bits are       b. An odd number of bits are
       inverted                            inverted

    c. It makes no difference


4. Suppose 4000 bit code words are to be transmitted and it is desired
   to use a Hamming code to correct  error bursts of up to 80 bits.
   How many of the 4000 bits must be used for ECC. (Hint: Fractional
   bit based strategies are not likely to be rewarded!)






5. Suppose an 8 bit code word is used.  How many code words are
   at a Hamming distance of exactly 2 from a given code word.

   a. 56                        b. 64

   c. 28                        d. 16


6. Suppose a generator polynomial of G(x) = x^4 is used.  Identify
   the errors that G(x) can detect.


   ____ a. E(x) = x^8


   ____ b. E(x) = x^6 + x^2


   ____ c. E(x) = x^8 + x^6


7. Suppose a generator polynomial of G(x) = x + 1 is used.  Identify
   the errors that G(x) can detect.

   ____ a. E(x) = x


   ____ b. E(x) = x^2 + 1


   ____ c. E(x) = x^5 + x^3







8. For the shift register shown above:

   a.  What generator polynomial is represented





   b.  What will be the NEW contents of the shift register
       after an input bit of "1" is processed.




9. Which of the following is capable of DETECTING error bursts of
   up to 32 bits  (circle ALL that apply)

   a. Parity                         b. 16 bit checksum

   c. CRC with deg 32 generator      d. 32 bit checksum


                      Computer Science 825
                         Quiz 8              Name _______________________

1. How should the pre-multiplying shift register be initialized?

   a. all 0's                      b. 1st 4 bits of the message


   c. both ways work fine


2. In protocol 2, ACK's were used but no sequence numbers were used
   on frames or ACK's.  Which of the following problems could occur.

   a. Lost frames would go          b. Lost ACK's would result in
      undetected.                      lost frames

   c. Lost acks would result in     d. Lost frames would result in
      duplicate frames.                duplicate frames.


3. In protocol 3, frames's had sequence numbers but ACKS did not.
   Protocol 3 could fail in the presence of:

   a. ACK's that were lost          b. ACK's that were excessively
                                       delayed

   c. Frames that were lost.        d. Either a or b



4. When protocol 3 failed, the failure resulted in:

   a. The loss of 2 frames          b. The loss of 1 frame and
                                       the duplication of 1 frame.

   c. The duplication of 2          d. The loss of 1 frame
      frames.


5. One way to prevent the specific failure that protocol 3 suffered
   is to not send an ACK when a duplicate frame is received. Adopting
   that strategy produces a protocol

   a. which is correct              b. which deadlocks on a lost frame

   c. which deadlocks on a lost     d. which deadlocks on both a lost
      ACK                              frame and on a lost ack.


6. The bisynch protocol introduced the use of the ENQ packet.
    An ENQ is used

   a. by the sender to request      b. Used by the receiver to
      that the last ACK be             request that the last
      retransmitted.                   packet be retransmitted
   c. Both of the above             d. Neither of the above.


7. A problem with the Bisync protocol is that it:

   a. allows undetected             b. fails on delayed acks
      duplication of packets

   c. deadlocks on lost Enq         d. operates only in stop and wait
                                       mode

8. Consider the following simplex connection.. Since the connection
   is simplex the sender side needs only nxtack and nxtsend state
   variables and the receiver side needs only nxtrecv. Assume that:
   the "ACK next frame expected" convention is used; the
   protocol uses sender and receiver window size = N;
   sequence numbers never wrap; and NO timeout and retransmits
   occur.

    nxtack  --------------------> nxtrecv
    nxtsend

   Answer the following T or F. At any instant in time:

   ____ a. nxtack must always be <= nxtrecv

   ____ b. nxtrecv may be < nxtack

   ____ c. nxtsend may be < nxtrcv

9. Suppose in a connection such as described in question 8 that
   after the connection has been idle for a while with
   nxtsend=nxtack=nxrecv=0 and the sender sends a burst of 5
   packets.  Which of the following values will reach "5" last

   a. nxtsend                       b. nxtrecv

   c. nxtack                        d. They will all reach 5 at
                                       the same instant

10. For each of the following combinations of propogation delay
    and error rate identify the most suitable variation of sliding
    window protocol. (The most suitable choice is the SIMPLEST
    one that doesn't incur a big performance penalty.)

    ___ a. No errors but packet time   1. Stop and Wait
           << propagation delay
    ___ b. No errors but packet time   2. Receiver buffering w/ out of
           >> propagation delay.          order retransmission
    ___ c. High errors and packet time
           << propagation delay        3. Receiver buffering w/ go back
                                          N sender

                                       4. Go back N.

11. Suppose a stop in wait protocol is used on a channel with a bit
    rate of 100,000 bits per second.  Data Packets are 10,000 bits
    long and Ack packets are 100 bits long.  One-way physical latency is
    0.5 microseconds.  After receiving the last bit of a packet it takes
    the receiver 100 microseconds to begin sending the ack.  What is the
    efficiency.
                      Computer Science 851
                           Quiz 9          Name _______________________

1. Suppose that a satellite link has a ROUND TRIP propagation
   delay of 500 ms. Suppose bit transmission rate is 100,000 bits
   per second and packets are 10000 bits long.

   a. What will the efficiency of this channel be if stop and wait
      protocol is used.








   b. How large (in packets) must the sender window be in order to
      obtain 100% efficiency if the channel is guaranteed error free.
      (i.e. give me the MINIMUM Sender Window Size I can use).





   c. What is the MINIMUM size of the seq/ack number in bits that
      is required to support receiver buffering with out of order
      retransmission.




2. The sender window logic in the sample protocol implementation
   used three indexes: nxtsend; nxtqueue; and
   nxtack. We said these values always remained in a specific relative
   order. The order was

   a. send <= queue <= ack              b. queue <= ack <= send

   c. ack <= queue <= send              d. send <= ack <= queue

   e. None of the above

3. The value of the counting semaphore wpcount (that counted the
   number of packets waiting to be written is given by: (assume
   no sequence # wrap).

   a. queue - ack                       b. send - queue

   c. send - ack                        d. queue - send


4. Suppose the sequence number has 4 bits.  Then the value of the
   semaphore numslots is: (assume modular arithmetic is properly
   handled)

   a. 16 - (queue - ack)                b. 16 - (queue - send)

   c. 15 - (queue - send)               d. 15 - (queue - ack)

5. Which of the following is an invariant (circle ALL that are
   correct).

   a. wpcount + numslots                b. numslots + nxtqueue - nxtack

   b. numslots + nxtsnd - nxtact        d. numslots + nxtsnd - nxtack +
                                           wpcount

6. A buffer in the protocol discussed in class cycled though a number
   of queues.. Associate each transition with the process that
   caused it. (Some answers may be used more than once or not at all).

      ____ 1. Read pending to network      a.  Network layer process
              input.

      ____ 2. Network input to link        b.  Queuemsg process
              station output
                                           c.  Timeout process
      ____ 3. Link output to
              sender window.               d.  Writelink process

       ___ 4. Sender window to free        e.  Readlink process
              list

7. The address byte in an SDLC packet always carries the address of

   a. The sender                 b. The receiver

   c. The primary station.       d. The secondary station.


8. Select the description which most accurately matches the use of
   the P/F bit in SDLC.

   a. 1 -> Poll and 0 -> Final    b. The bit means poll or not poll
                                     when a secodary sends final or
                                     not final when a primary sends.

   c. The bit means poll or not   d. The bit means poll or not poll
      poll to the sender final       when the primary sends final or
      or not final to the receiver   not final when a secondary sends.

9. Supervisory frames in SDLC carry

   a. Both sequence numbers and    b. Sequence numbers but no ack
      ack numbers.                    numbers

   c. Ack numbers but no sequence  d. No numbers at all.
      numbers.

10. In ATM framing, after a transition from the HUNT to PRE_SYNCH occurs

   a. The algorithm continues      b. The algorithm delays 32 bits
      to test every bit to see        before making another CRC test
      if the most recent 8 bits
      are a valid CRC for the
      previous 32.

   c. The algorithm delays 424 bits
      before testing again.
                      Computer Science 851
                           Quiz A          Name _______________________

1. Answer the following T or F

   ___ a. The SSCOP is a stop and wait protocol


   ___ b. In the SSCOP data packets carry both sequence numbers and
          ack numbers


   ___ c. Two different sequence numbering spaces are used for polling
          and for sending data frames.


 2. Suppose the last packet that has been correctly received carried
    sequence number 5 and the receiver has 10 free buffers. A STAT
    packet generated in this state should carry what values for N(R)
    and N(MR)

    N(R) =


    N(MR) =


3. Each routing update packet propagates

   a. Across the entire net in SPF    b. Only to adjacent neighbors in SPF
      and in Bellman-Ford                 and Bellman Ford

   c. Across entire net in SPF but    d. Across entire net in B-F but only
      only to adjacent neighbors in B-F   to adjacent neighbors is SPF


4. Let N = number of nodes in a network and M = the average number
   of links / node.

   a. The size of a routing info packet in SPF is of order

      1. M      2. N      3. N ^ 2       4. N ^ M

   b. The total number of ROUTING PACKET transmissions at each routing
      exchange in Bellman-Ford within the entire network is of order:

       1. M    2. N     3. N ^ 2    4. M ^ 2    5. N * M

   c. The total amount of DATA TRANSFERRED at each routing
      exchange in Bellman Ford within the entire network is of order:

       1. M^2    2. N ^ 2 * M    3. N * M ^ 2    4. N ^ 2    5. N * M

   d. The total amount of DATA TRANSFERRED at each routing
      exchange in SPF  within the entire network is of order:

       1. M^2    2. N ^ 2 * M    3. N * M ^ 2    4. N ^ 2    5. N * M


5. The flooding routing algorithm is used to route routing updates
   in

   a. SPF routing                        b. Bellman-Ford routing

   c. Not used in either                 d. both


6. Suppose the Bellman-Ford routing algorithm is being used and station
   B receives the following routing updates from neighbors A and C
   Suppose BA delay = 3, BC delay = 5
   Complete the routing table for B.,

                   Total
      A  C         Cost VIA
   A  0  1             |
   --------       ----------
   B  5 11             |
   --------       ----------
   C  2  0             |
   --------       ----------
   D  8  5             |
   --------       ----------
   E 12  8             |
   --------       ----------


7. Each routing update packet propagates

   a. Across the entire net in SPF    b. Only to adjacent neighbors in SPF
      and in Bellman-Ford                 and Bellman Ford

   c. Across entire net in SPF but    d. Across entire net in B-F but only
      only to adjacent neighbors in B-F   to adjacent neighbors is SPF

8. The relationship between error rate and the desirability of using
   a reliable connection oriented network layer versus an unreliable
   datagram oriented network layer is that:

   a. Many hops with high error     b. Many hops with high error
      rates favors datagram service    rates favors reliable connection
                                       oriented service.
   c. The number of hops and the
      error rates have no particular
      effect.

9. Suppose all nodes run the distributed SPF algorithm using the same
   cost matrices.  Answer the following T or F.

   ___ a. The routing trees computed by all nodes are identical

   ___ b. If an edge of the general graph is in one station's route
          tree then it is in ALL station's route trees.

   ___ c. If node A's route to node H passes through node E then
          the first hop to node H in node E's tree will be the same
          edge as the next hop from node E in node A's tree.
                     Computer Science 851
                           Quiz B           Name _______________________

1. Preallocation of resources is a practical mechanism for congestion
   avoidance

   a. Only for reliable connnection      b. for either reliable or unreliable
      oriented network layers               connection oriented networks

   c. Only for connection-less network   d. Works fine for all of the above
      layers

2. Packet discarding is a practical mechanism for congestion
   avoidance

   a. Only for unreliable connnection   b. for either reliable or unreliable
      less  network layers                 connection less networks

   c. For unreliable connection         d. Works fine for all of the above
      oriented and  unreliable
      connection less network layers

3. a. Suppose network addresses are 20 decimal digits and flat routing tables
      are used. What is the maximum number of entries that may
      be required in a routing table.




   b. Suppose hierarchical routing is used and the addresses
      are partitioned as an 6 digit Area address; an 8 digit Network
      address and a 6 digit host addres. Now what is the maximum
      number of routing table entries.




4. Adding support for which of the following is most likely to
   require additional persistent state in a router:

   a. multicasting                           b. broadcasting

   c. both                                   d. neither


5. In the network shown suppose all hosts know
   the optimal route to A (hop count metric)
   and A initiates a reverse path forwarding
   broadcast. How many unnecessary transmissions
   will occur?








6. Order the following broadcast algorithms according to the number
   of packet transmissions needed to complete a broadcast (1 = least
   transmissions; 3 = most).

   ______ a. Reverse Path Forwarding

   ______ b. Spanning tree.

   ______ c. Flooding


7. Routing updates in BGP carry a list consisting of each

   a. router through which a route      b. IP network through
      passes                               which a route passes

   c. Autonomous System through         d. None of the above
      which a route passes.

8. The number of prefixes in IP core router lookup tables is closest to:

   a. 100                                b. 1000

   c. 100,000                            c. 100,000,000


9. The delivery of streaming media such as live radio and TV shows
   on the internet is most commonly done today via:

   a. unicast to each recipient       b. multicast

   c. broadcast

10. The BGP protocol used in routing among autonomous systems, is

   a. A distance-vector protocol      b. A link-state protocol of
      of the Bellman Ford family         the OSPF family

   c. A reverse path forwarding       d. A backward learning
      protocol.                          protocol

11. Answer the following T or F depending upon whether the item
    was a factor in the  poor performance in the Bellman-Ford
    algorithm as originally used in the Internet

    ____ a. Too much time was spent computing very precise average
            queue lengths.

    ____ b. Routing updates were not generated frequently enough


                     Computer Science 851
                           Quiz C           Name _______________________

1. Suppose three traffic arrival streams have the same mean arrival rate
   of 400 pkts/second and that the service rate is 600 pkts / second.
   Order the streams from 1 (smallest queue length)
   to 3 (largest queue length) according to the the following characteristics:

   ___ 1.  Variance = 10,000       No significant correlation

   ___ 2.  Variance = 100          Evidence of self-similarity

   ___ 3.  Variance = 10,000       Evidence of self-similarity

Suppose an ATM cell arrival process is found to have a mean arrival
rate of  300 cells per second and the outgoing link can send at a rate
of 500 cells per second.  (Applies to Q 2 - 5)

2. In the long term, what percent of the time is the link busy?




3. The observed queue length will increase

   a. only when more that 300  cells    b. only when more than 500
      arrive in a second                  cells arrive in a second

   c. only when more that 800  cells
      arrive in a second.

4.  Suppose that the arrival distribution is found to be approximately
    Gaussian (a.k.a. normal (bell-shaped-curve)) with variance of
    about 400. Would you expect signficant queuing delays in such a system?
    Hint: For the Gaussian distribution P[observing a value more than
    three standard deviations from the mean] ~ 0.013.)

    a. Yes, huge queues               b No, modest queues of around 5 cells
                                        most of the time.

    c. Almost no queuing

5. The likelihood of observing 500 arrivals in a random second

   a. depends on both the variance     b. depends on the variance but
      and degree of self-similarity       not degree of self-similarity

   c. depends on degree of self-sim    d. depends on neither variance
      but not the variance                nor self-similarity

6. The primary objective of the spanning tree algorithm in a transparent
   bridge system is to:

   a. Reduce the number of         b. Prevent indefinite packet looping.
      destination unknowns

   c. Ensure that the optimal      d. All of the above.
      route is taken.

7. Which routing algorithm is used by the spanning tree bridge
   if the location of the destination node is UNKNOWN?

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest past first.


8. Which routing algorithm is used by the source routing bridge
   in routing "discovery" packets to the destination.

   a. Spanning tree.              b. Flooding

   c. Backward learning.          d. Shortest path first.

9. With respect to the objective of Shortest Path Routing, which of
   the two bridging techniques we studied is superior.

   a. Spanning tree                b. Source routing

   c. Both provide optimal paths


10. When IP packets are fragmented they must be fragmented on

    a. an 8 bit boundary           b. an 8 byte boundary

    c. anywhere in the packet


11. Each time a router forward an IP packet it should decrement the TTL by

    a. 1                           b. the number of seconds it held the pkt

    c. the number of ms it held the packet



12. Consider the bridged network shown. Circles are bridges and lines
    LANs. Mark each interface on each bridge "R", "D", or "N" depending
    up whether it is the "Root Port", "Designated bridge port for the LAN",
    on "NOT in the spanning tree".










                     Computer Science 851
                           Quiz D           Name _______________________

1. The full 20 byte ATM address is used in (circle all that
   require the full address).

   a. SVC setup                          b. Routing of individual
                                            cells of an established SVC

   c. PVC setup                          d. Routing of PVC cells


2. The number of address bytes that each ATM host "inherits"
    from the switch to which it is attached is:

    a. 6                                  b. 13

    c. 14                                 d. 19


3. The connection identifier (vpi, vci) for a new SVC is assigned by

    a. the switch to which the host         b. the originating host O/S
       is connected

    c. the application program              d. the destination host O/S


4. Suppose a host connected to router A wants to connect to router D
    through the path (A, B, E, D). Update the routing tables using the
    label switching algorithm described in class: (you will need to add
    one line to each of the 4 tables).


    Router A          Router B         Router E         Router D
    From   To        From   To         From   To        From   To

    H 0   B 0        A 0   E 0         G 0   D 0        E 0   H 0
    H 1   B 1        A 1   E 1         B 0   F 0        K 0   F 0
    B 0   C 0        E 0   A 0         B 1   F 1        K 1   F 1
    H 2   C 1        G 0   E 2         B 2   G 0


5. Suppose Tomlinson's clock proposal is used with a 16 bit sequence
   number and a clock that ticks 2048 times a second. Suppose maximum
   packet lifetime is 8 seconds.

   a. What is the MINIMUM amount of time that can elapse before
      sequence number resynchronization must occur.





   b. How often will synchronization be needed if a packet is generated
      at 5/8 the maximum rate.




6. Which of the following is an ATM network layer not permitted
   to do

    a. Discard cells                    b. Deliver cells with multiple
                                           bit errors

    c. Reorder cells                    d. All of the above


7. Default routes are widely used for Internet scope routing by:

   a. Only host systems               b.  Host systems and routers in
                                          stub Autonomous systems

   c. All hosts and all routers
      in the internet


8. Which was of the following was NOT a design objective of IPV6.

   a. Enlarge the internet address      b. Provide better support
      space.                               for mobile hosts.

   c. Provide additional fragmentation  d. Reduce computing time and table
      facilities to make it more ATM       size requirments in backbone
      compatible.                          routers


9. The principal factor that makes it more difficult to construct
   a reliable transport protocol over an unreliable network layer
   than to construct a reliable data link protocol over an unreliable
   wire is:

   a. An unreliable network layer         b. An unreliable network layer
      may lose packets but wire              can cause out of order delivery
      cannot.                                with big delays but a wire cannot.

   c. The unreliable network layer        d. Both a. and b. apply equally.
      will never deliver damaged
      packets like the wire does.

10. An implementation of Tomlinson's strategy requires:

    a. A real time clock that ticks at    b. A known upper bound on packet
       least as fast as packets can be       lifetime.
       generated.

    c. A real time clock that ticks no    d. Both a. and b.
       faster than packets can be
       generated.

5. The number of distinct 20 byte ATM addresses that can normally be
   associated with a particular end system AT A GIVEN TIME is:

   a. 1                                  b. 2^8

   c. 2^20                               d. 2^160
